***********************************************************************
* Program....: SHOWPARAM.PRG
* Author.....: Paul Maskens & Andy Kramek
* Date.......: October 25, 2000
* Compiler...: Visual FoxPro 06.00.8862.00 for Windows
* Purpose....: Illustrate the effect of passing by Value and by Reference
* Prototype..: DO ShowParam
***********************************************************************
LOCAL lcName, lnVal
*** What's the current setting
lcOldSet = SET("UDFPARMS")
SET UDFPARMS TO VALUE
CLEA
? 'UDFPARMS is now set to VALUE'
?

*** Let's see what happens to these local variables when we pass as a procedure
STORE 10 TO lnVal
STORE 'Fred' TO lcName
*** Call as a PROCEDURE Call (by Reference)
? 'Call as Procedure: lnVal = ' + PADL( lnVal, 4 ), 'lcName = ' + ALLTRIM( lcName )
DO ShowRes WITH lnVal, lcName
? 'After Call as Procedure: lnVal = ' + PADL( lnVal, 4 ), 'lcName = ' + ALLTRIM( lcName )
?
*** Let's see what happens to these local variables when we pass as a function
STORE 10 TO lnVal
STORE 'Fred' TO lcName
*** Call as a PROCEDURE Call (by Reference)
? 'Call as Function: lnVal = ' + PADL( lnVal, 4 ), 'lcName = ' + ALLTRIM( lcName )
ShowRes( lnVal, lcName )
? 'After Call as Function: lnVal = ' + PADL( lnVal, 4 ), 'lcName = ' + ALLTRIM( lcName )

*** Now change the setting
SET UDFPARMS TO REFERENCE
? 
? 'UDFPARMS is now set to REFERENCE'
?
*** Let's see what happens to these local variables when we pass as a procedure
STORE 10 TO lnVal
STORE 'Fred' TO lcName
*** Call as a PROCEDURE Call (by Reference)
? 'Call as Procedure: lnVal = ' + PADL( lnVal, 4 ), 'lcName = ' + ALLTRIM( lcName )
DO ShowRes WITH lnVal, lcName
? 'After Call as Procedure: lnVal = ' + PADL( lnVal, 4 ), 'lcName = ' + ALLTRIM( lcName )
?
*** Let's see what happens to these local variables when we pass as a function
STORE 10 TO lnVal
STORE 'Fred' TO lcName
*** Call as a PROCEDURE Call (by Reference)
? 'Call as Function: lnVal = ' + PADL( lnVal, 4 ), 'lcName = ' + ALLTRIM( lcName )
ShowRes( lnVal, lcName )
? 'After Call as Function: lnVal = ' + PADL( lnVal, 4 ), 'lcName = ' + ALLTRIM( lcName )

*** Restore Sanity - please!
SET UDFPARMS TO &lcOldSet
RETURN



FUNCTION ShowRes
LPARAMETERS tnInVal, tcInString
*** Modify the parameters
tnInVal = tnInVal + 10
tcInString = tcInString + " Smith"
*** Show them
? 'Inside Function: tnInVal = ' + PADL( tnInVal, 4 ), 'tcInstring = ' + ALLTRIM( tcInstring )
RETURN
